// Java class com.rpgsnack.runtime.mobile.Mobile is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=com.rpgsnack.runtime github.com/hajimehoshi/rpgsnack-runtime/mobile
//
// File is generated by gobind. Do not edit.
package com.rpgsnack.runtime.mobile;

import go.Seq;

public abstract class Mobile {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Mobile() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	private static final class proxyRequester implements Seq.Proxy, Requester {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyRequester(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native void requestAsset(long requestID, String key);
		public native void requestChangeLanguage(long requestID, String lang);
		public native void requestGetIAPPrices(long requestID);
		public native void requestInterstitialAds(long requestID, boolean forceAds);
		public native void requestOpenLink(long requestID, String linkType, String data);
		public native void requestPurchase(long requestID, String productID);
		public native void requestRestorePurchases(long requestID);
		public native void requestReview();
		public native void requestRewardedAds(long requestID, boolean forceAds);
		public native void requestSavePermanent(long requestID, byte[] data);
		public native void requestSaveProgress(long requestID, byte[] data);
		public native void requestSendAnalytics(String eventName, String value);
		public native void requestShareImage(long requestID, String title, String message, byte[] image);
		public native void requestShowShop(long requestID, String data);
		public native void requestTerminateGame();
		public native void requestUnlockAchievement(long requestID, long achievementID);
		public native void requestVibration(String vibrationType);
	}
	
	
	public static native void appendAssetBytes(byte[] bytes);
	public static native boolean isRunning();
	public static native void respondAsset(long id, boolean success, byte[] data) throws Exception;
	public static native void respondChangeLanguage(long id) throws Exception;
	public static native void respondGetIAPPrices(long id, boolean success, byte[] prices) throws Exception;
	public static native void respondInterstitialAds(long id) throws Exception;
	public static native void respondOpenLink(long id) throws Exception;
	public static native void respondPurchase(long id, boolean success, byte[] purchases) throws Exception;
	public static native void respondRestorePurchases(long id, boolean success, byte[] purchases) throws Exception;
	public static native void respondRewardedAds(long id, boolean success) throws Exception;
	public static native void respondSavePermanent(long id) throws Exception;
	public static native void respondSaveProgress(long id) throws Exception;
	public static native void respondShareImage(long id) throws Exception;
	public static native void respondShowShop(long id, boolean success, byte[] purchases) throws Exception;
	public static native void respondUnlockAchievement(long id) throws Exception;
	public static native void setPlatformData(String key, String value) throws Exception;
	public static native void setScreenSize(long widthInDP, long heightInDP);
	public static native void start(long widthInDP, long heightInDP, Requester requester, byte[] project, byte[] progress, byte[] permanent, byte[] purchases, String language) throws Exception;
	public static native void update() throws Exception;
	public static native void updateTouchesOnAndroid(long action, long id, long x, long y);
	public static native void updateTouchesOnIOS(long phase, long ptr, long x, long y);
}
